

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>&lt;no title&gt; &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>&lt;no title&gt;</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/api/posydon.active_learning.psy_cris.regress.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <span class="target" id="module-posydon.active_learning.psy_cris.regress"></span><dl class="py class">
<dt id="posydon.active_learning.psy_cris.regress.Regressor">
<em class="property">class </em><code class="sig-prename descclassname">posydon.active_learning.psy_cris.regress.</code><code class="sig-name descname">Regressor</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">TableData_object</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.9)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
<p>Perform regression and interpolation with a variety of different
regression algorithms. Regression algorithms are trained by class
and by output column in the data set and stored as instance variables
in nested dictionaries.
This class inlcudes a ‘cross validation’ method that trains with the
holdout method but calculates differences instead of a single accuracy.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>TableData_object</strong> (<em>instance of &lt;class</em><em>, </em><em>TableData&gt;</em>) – An instance of the TableData class.</p>
</dd>
</dl>
<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.cross_validate">
<code class="sig-name descname">cross_validate</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_name</span></em>, <em class="sig-param"><span class="n">class_key</span></em>, <em class="sig-param"><span class="n">col_key</span></em>, <em class="sig-param"><span class="n">alpha</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.cross_validate"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.cross_validate" title="Permalink to this definition">¶</a></dt>
<dd><p>Our method of cross validation for regression. Train on a subset of the
data and predict values for the rest. Then calculate the difference between
the true and predicted value.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_name</strong> – Regressor name to use for analysis.</p></li>
<li><p><strong>class_key</strong> – Class key to take differences.</p></li>
<li><p><strong>col_key</strong> – Column key to take differences.</p></li>
<li><p><strong>alpha</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Fraction of data set used to find differences.</p></li>
<li><p><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print useful information.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>percent_diffs</strong> (<em>array</em>) – Percent difference.</p></li>
<li><p><strong>diffs</strong> (<em>array</em>) – Absolute difference.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.fit_gaussian_process_regressor">
<code class="sig-name descname">fit_gaussian_process_regressor</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_keys</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">data_interval</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.fit_gaussian_process_regressor"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.fit_gaussian_process_regressor" title="Permalink to this definition">¶</a></dt>
<dd><p>Fit a Gaussian Process regressor
implementation from: sklearn.gaussian_process
(<a class="reference external" href="https://scikit-learn.org/stable/modules/gaussian_process.html">https://scikit-learn.org/stable/modules/gaussian_process.html</a>)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>class_keys</strong> – List of classes to train on.</p></li>
<li><p><strong>col_keys</strong> – If multiple classes are given, it is assumed they all contain
the supplied columns.</p></li>
<li><p><strong>data_interval</strong> (<em>array</em><em>, </em><em>optional</em>) – Array indicies of data used to train (training on a subset).
if None (default) train on whole data set</p></li>
<li><p><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print statements with more information while training.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>regressor_holder</strong> – Ordered by class specific data and then by column. Nested dictionary
maps to a trained GaussianProcessRegressor object.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)">dict</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.fit_linear_ND_interpolator">
<code class="sig-name descname">fit_linear_ND_interpolator</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_keys</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">data_interval</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.fit_linear_ND_interpolator"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.fit_linear_ND_interpolator" title="Permalink to this definition">¶</a></dt>
<dd><p>Fit linear ND interpolator - linear interpolation between data points in N dimensions
implementation from: scipy.interpolate.LinearNDInterpolator
(<a class="reference external" href="https://docs.scipy.org/doc/scipy/reference/interpolate.html">https://docs.scipy.org/doc/scipy/reference/interpolate.html</a>)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>class_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of classes to train on.</p></li>
<li><p><strong>col_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of columns in the class to train on.
If multiple classes are given, it is assumed they all contain
the supplied columns.</p></li>
<li><p><strong>data_interval</strong> (<em>array</em><em>, </em><em>optional</em>) – Array indicies of data used to train (training on a subset).
If None (default) train on whole data set</p></li>
<li><p><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print statements with more information while training.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>regressor_holder</strong> – Ordered by class specific data and then by column. Nested dictionary
maps to a trained linearNDinterpolator object.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)">dict</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.fit_rbf_interpolator">
<code class="sig-name descname">fit_rbf_interpolator</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_keys</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">data_interval</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.fit_rbf_interpolator"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.fit_rbf_interpolator" title="Permalink to this definition">¶</a></dt>
<dd><p>Fit RBF interpolator - binary classification (one against all)
implementation from: scipy.interpolate.Rbf
(<a class="reference external" href="https://docs.scipy.org/doc/scipy/reference/interpolate.html">https://docs.scipy.org/doc/scipy/reference/interpolate.html</a>)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>class_keys</strong> – List of classes to train on.</p></li>
<li><p><strong>col_keys</strong> – If multiple classes are given, it is assumed they all contain
the supplied columns.</p></li>
<li><p><strong>data_interval</strong> (<em>array</em><em>, </em><em>optional</em>) – Array indicies of data used to train (training on a subset).
if None (default) train on whole data set</p></li>
<li><p><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print statements with more information while training.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>regressor_holder</strong> – Ordered by class specific data and then by column. Nested dictionary
maps to a trained RBF object.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)">dict</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.get_cross_val_data">
<code class="sig-name descname">get_cross_val_data</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_key</span></em>, <em class="sig-param"><span class="n">col_key</span></em>, <em class="sig-param"><span class="n">alpha</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.get_cross_val_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.get_cross_val_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Randomly sample the data set and seperate training and test data.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>class_key</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a><em>, </em><em>class_dtype</em><em>(</em><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a><em> or </em><em>other</em><em>)</em>) – Class key specifying the class to get data from.</p></li>
<li><p><strong>col_key</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Column key specifying the output column to get data.</p></li>
<li><p><strong>alpha</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Fraction of data set to use for training. (0.05 = 5% of data set)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>cross_val_test_input_data</strong> (<em>ndarray</em>) – Input data used to test after training on a subset.</p></li>
<li><p><strong>cross_val_test_output_data</strong> (<em>ndarray</em>) – Output data used to test after training on a subset.</p></li>
<li><p><strong>sorted_rnd_int_vals</strong> (<em>array</em>) – Indicies of original data that were used as training points.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.get_max_APC_val">
<code class="sig-name descname">get_max_APC_val</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_name</span></em>, <em class="sig-param"><span class="n">class_key</span></em>, <em class="sig-param"><span class="n">args</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.get_max_APC_val"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.get_max_APC_val" title="Permalink to this definition">¶</a></dt>
<dd><p>For a given class, and regression method. Return the maximum
interpolated average percent change value across all APC columns in
the class sorted data set. Helper method for constructing target
distributions for the Sampler.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Name of regression algorithm to use.</p></li>
<li><p><strong>class_key</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Class key to use for data.</p></li>
<li><p><strong>args</strong> (<em>array</em>) – Locations for the APC value to be predicted.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>max_APC</strong> (<em>float</em>) – Maximum average percent change (APC) value.</p></li>
<li><p><strong>which_col_max</strong> (<em>int</em>) – Index of which column had the maximum APC.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.get_predictions">
<code class="sig-name descname">get_predictions</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_names</span></em>, <em class="sig-param"><span class="n">class_keys</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">test_input</span></em>, <em class="sig-param"><span class="n">return_std</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.get_predictions"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.get_predictions" title="Permalink to this definition">¶</a></dt>
<dd><p>Get predictions from trained regressors for a set of input parameters.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_names</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of regressor algorithm names to use to predict.</p></li>
<li><p><strong>class_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of classes to get predictions for.</p></li>
<li><p><strong>col_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of columns to get predictions for.</p></li>
<li><p><strong>test_input</strong> (<em>ndarray</em>) – Array of input points for which predictions will be found.</p></li>
<li><p><strong>return_std</strong> (<em>optional</em><em>, </em><a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – Return the STD is when using GaussianProcessRegressor.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>predictions</strong> – Dictionary ordered by algorithm, class, and output column mapping
to an array of predictions for the test input points.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)">dict</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.get_regressor_name_to_key">
<code class="sig-name descname">get_regressor_name_to_key</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">name</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.get_regressor_name_to_key"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.get_regressor_name_to_key" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the standard key (str) of a classifier.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.get_rnd_test_inputs">
<code class="sig-name descname">get_rnd_test_inputs</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_name</span></em>, <em class="sig-param"><span class="n">N</span></em>, <em class="sig-param"><span class="n">other_rng</span><span class="o">=</span><span class="default_value">{}</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.get_rnd_test_inputs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.get_rnd_test_inputs" title="Permalink to this definition">¶</a></dt>
<dd><p>Produce randomly sampled ‘test’ inputs inside domain of input_data.
Input data is seperated by class.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>class_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Class name to specify which input data you want to look at.</p></li>
<li><p><strong>N</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – Number of test inputs to return.</p></li>
<li><p><strong>other_rng</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)"><em>dict</em></a><em>, </em><em>optional</em>) – Change the range of random sampling in desired axis. By default,
the sampling is done in the range of the training data.
The axis is specified with an integer key and the value
is a list specifying the range. {1:[min, max]}</p></li>
<li><p><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print diagnostic information. (default False)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><strong>rnd_test_points</strong> – Test points randomly sampled in the range of the training data
in each axis unless otherwise specified in ‘other_rng’.
Has the same shape as input data from TableData.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.mult_diffs">
<code class="sig-name descname">mult_diffs</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_name</span></em>, <em class="sig-param"><span class="n">class_key</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">alpha</span></em>, <em class="sig-param"><span class="n">cutoff</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.mult_diffs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.mult_diffs" title="Permalink to this definition">¶</a></dt>
<dd><p>For multiple calls to cross_validate.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Name of regression algorithm to use.</p></li>
<li><p><strong>class_key</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a><em>, </em><em>class_dtype</em><em>(</em><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a><em> or </em><em>other</em><em>)</em>) – Name of class data to use.</p></li>
<li><p><strong>col_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Column keys to cross validate on.</p></li>
<li><p><strong>alpha</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Fraction of data set to cross validate on.</p></li>
<li><p><strong>cutoff</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Sets the cutoff percentage at which to calculate
the fraction of the data set above or below.</p></li>
<li><p><strong>vebose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a><em>, </em><em>optional</em>) – Print useful diagnostic information.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>p_diffs_holder</strong> (<em>ndarray</em>) – Percent differencs per column.</p></li>
<li><p><strong>attr_holder</strong> (<em>ndarray</em>) – Contains the number of points outside the cutoff, mean,
and standard deviation of the percent difference calculations.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.plot_regr_data">
<code class="sig-name descname">plot_regr_data</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">class_name</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.plot_regr_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.plot_regr_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Plot all regression data from the chosen class.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>class_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.9)"><em>str</em></a>) – Specify what class data will plotted.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Plots with all regression data for a given class.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>matplotlib figure</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.show_structure">
<code class="sig-name descname">show_structure</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.show_structure"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.show_structure" title="Permalink to this definition">¶</a></dt>
<dd><p>Show (print) the structure of the regression data.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.train">
<code class="sig-name descname">train</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_name</span></em>, <em class="sig-param"><span class="n">class_keys</span></em>, <em class="sig-param"><span class="n">col_keys</span></em>, <em class="sig-param"><span class="n">di</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.train"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.train" title="Permalink to this definition">¶</a></dt>
<dd><p>Train a regression algorithm.</p>
<dl class="simple">
<dt>Implemented regressors:</dt><dd><p>LinearNDInterpolator (‘linear’, …)
Radial Basis Function (‘rbf’, …)
GaussianProcessRegressor (‘gp’, …)</p>
</dd>
</dl>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">rg</span> <span class="o">=</span> <span class="n">Regressor</span><span class="p">(</span> <span class="n">TableData_object</span> <span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">rg</span><span class="o">.</span><span class="n">train</span><span class="p">(</span> <span class="s1">&#39;linear&#39;</span><span class="p">,</span> <span class="n">di</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">Ndatapoints</span><span class="p">,</span> <span class="mi">5</span><span class="p">),</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">True</span> <span class="p">)</span>
</pre></div>
</div>
<p>Trained regressor objects are uniquely defined by the algorithm used to
train, the data set used to train (grouped by class), and finally the
output column (there could be more than one). This motivates the data
structure for storing the regressor objects as follows:</p>
<blockquote>
<div><p>Algorithm -&gt; Class -&gt; Output Column -&gt; Object</p>
</div></blockquote>
<dl class="simple">
<dt>Here is more realistic example of what it could look like:</dt><dd><p>{RBF: {“class_1”: {“output_1”: {instance of scipy.interpolate.rbf} } } }</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_name</strong> (<em>string</em>) – Name of regressor to train.</p></li>
<li><p><strong>class_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of class(es) to train on.</p></li>
<li><p><strong>col_keys</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a><em> or </em><a class="reference external" href="https://docs.python.org/3/library/constants.html#None" title="(in Python v3.9)"><em>None</em></a>) – For a given class, what columns to train on.
If None, it trains on all columns in one class.</p></li>
<li><p><strong>di</strong> (<em>optional</em><em>, </em><em>array</em>) – Array indicies of data used to train (training on a subset).
If None (default) - train on whole data set</p></li>
<li><p><strong>verbose</strong> (<em>optional</em><em>, </em><a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – Print statements with more information while training.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/constants.html#None" title="(in Python v3.9)">None</a></p>
</dd>
</dl>
<p>Note: You can train mutliple classes at once as long as they have the same
columns specified in col_keys.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.active_learning.psy_cris.regress.Regressor.train_everything">
<code class="sig-name descname">train_everything</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">regressor_names</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#Regressor.train_everything"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.Regressor.train_everything" title="Permalink to this definition">¶</a></dt>
<dd><p>Train all classes and columns with the specified list of regressor names.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>regressor_names</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – List of strings specifying all the regressors to train.</p></li>
<li><p><strong>verbose</strong> (<em>optional</em><em>, </em><a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – Print useful information.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><a class="reference external" href="https://docs.python.org/3/library/constants.html#None" title="(in Python v3.9)">None</a></p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt id="posydon.active_learning.psy_cris.regress.makehash">
<code class="sig-prename descclassname">posydon.active_learning.psy_cris.regress.</code><code class="sig-name descname">makehash</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/active_learning/psy_cris/regress.html#makehash"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.active_learning.psy_cris.regress.makehash" title="Permalink to this definition">¶</a></dt>
<dd><p>Used for managing nested dictionaries.</p>
</dd></dl>



           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>